C**********************************************************************
C 11.2@KEXϕ
C**********************************************************************
      implicit none
      integer,parameter :: MM=6
      real :: x(MM),alpha(MM)
      integer :: n,j
      real :: a,b,S,SS,Stmp,f

      a=0.0
      b=5.0

      write(*,*) "Please input 1-6 as n."
      read(*,*) n

! \11.1
      if(n.eq.1) then
        x(1)= 0.0000000000
        alpha(1)=2.0000000000
      else if(n.eq.2) then
        x(1)=-0.5773502692
        x(2)= 0.5773502692
        alpha(1)=1.0000000000
        alpha(2)=1.0000000000
      else if(n.eq.3) then
        x(1)=-0.7745966692
        x(2)= 0.0000000000
        x(3)= 0.7745966692
        alpha(1)=0.5555555556
        alpha(2)=0.8888888889
        alpha(3)=0.5555555556
      else if(n.eq.4) then
        x(1)=-0.8611363116
        x(2)=-0.3399810436
        x(3)= 0.3399810436
        x(4)= 0.8611363116
        alpha(1)=0.3478548451
        alpha(2)=0.6521451549
        alpha(3)=0.6521451549
        alpha(4)=0.3478548451
      else if(n.eq.5) then
        x(1)=-0.9061798459
        x(2)=-0.5384693101
        x(3)= 0.0000000000
        x(4)= 0.5384693101
        x(5)= 0.9061798459
        alpha(1)=0.2369268851
        alpha(2)=0.4786286705
        alpha(3)=0.5688888889
        alpha(4)=0.4786286705
        alpha(5)=0.2369268851
      else if(n.eq.6) then
        x(1)=-0.9324695142
        x(2)=-0.6612093865
        x(3)=-0.2386191861
        x(4)= 0.2386191861
        x(5)= 0.6612093865
        x(6)= 0.9324695142
        alpha(1)=0.1713244924
        alpha(2)=0.3607615730
        alpha(3)=0.4679139346
        alpha(4)=0.4679139346
        alpha(5)=0.3607615730
        alpha(6)=0.1713244924
      else
        write(*,*) "Please input 1-6 as n."
        read(*,*) n
      end if

      Stmp=0.0
      do j=1,n
        Stmp=Stmp+alpha(j)*f(((b-a)*x(j)+(a+b))/2.0)
      end do

      S=(b-a)/2.0*Stmp
! ʂ̏o
      write(*,901) "S(Gauss integration) =         ", S

C**********************************************************************
C [Ql] ϕɂvZ
      write(*,*) " "
      write(*,*) "[for reference]"
      SS=(sin(b)+1.0/2.0*b**2)-(sin(a)+1.0/2.0*a**2)
      write(*,901) "S(integral from a to b) =     ", SS

  901 format(A30,f10.6)
      end

C**********************************************************************
C ֐f̒`
C**********************************************************************
      real function f(x)
      implicit none
      real :: x

      f=cos(x)+x
      end function

