C**********************************************************************
C 12.2@4xQENb^@
C**********************************************************************
      implicit none
      integer,parameter :: NM=20
      real :: f,a,b,c,h,s1,s2,s3,s4,exact
      real :: x(0:NM),y(0:NM)
      integer :: n,j

C ASY菇PD
      a=0.0
      b=2.0
      c=0.5
      n=20

C ASY菇QD
      h=(b-a)/real(n)
      x(0)=a
      y(0)=c

C ASY菇RD
      do j=0,n-1
        s1=f(x(j),y(j))
        s2=f(x(j)+h/2.0,y(j)+h*s1/2.0)
        s3=f(x(j)+h/2.0,y(j)+h*s2/2.0)
        s4=f(x(j)+h,y(j)+h*s3)
        x(j+1)=x(j)+h
        y(j+1)=y(j)+h/6.0*(s1+2.0*s2+2.0*s3+s4)
      end do

C ʂ̏o
  900 format(A6, 2A15)
  901 format(f6.2, 2f15.6)
      write(*,900) "x(j)", "calculated", "exact"
      do j=0,n
        write(*,901) x(j),y(j),exact(x(j))
      end do
      end

C**********************************************************************
C ֐̒`
C**********************************************************************
      real function f(x,y)
      real :: x,y

      f=(x**2+x+1.0)-(2.0*x+1.0)*y+y**2
      end function
C**********************************************************************
C vZ邽߂̊֐
C**********************************************************************
      real function exact(x)
      real :: x

      exact=(x*exp(x)+x+1.0)/(exp(x)+1.0)
      end function